<?php

header('Content-Type: application/json');
require_once(dirname(__FILE__) . '/../../includes/common.inc.php');

pre_init();
init_session(true);

grab_request_vars();
check_prereqs();
check_authentication(false, false, false, true);

$requestType = $_SERVER['REQUEST_METHOD'];
header('Content-Type: application/json');

switch ($requestType) {
    case 'GET':
        switch(grab_request_var("command", "")) {
            case "name":
                $response = array('display_full_name' =>     get_product_name(),
                                  'display_short_name' =>    get_product_name(true),
                                  'overridden_full_name' =>  get_product_name(false, true),
                                  'overridden_short_name' => get_product_name(true, true));
                break;
            case "version":
                $response = array('version' => get_product_version(),
                                  'release' => get_product_release(),
                                  'build'   => get_build_id());
                break;
            case "update_url":
                $response = array('update_url' => get_update_check_url());
                break;
            case "branding":
                $response = array();
                if (custom_branding()) {
                    global $bcfg;
                    /* Notable omission: license_file, which is a filesystem path */
                    $response = array(
                        'product_name'            => $bcfg['product_name'],
                        'product_name_short'      => $bcfg['product_name_short'],
                        'major_version'           => $bcfg['major_version'],
                        'minor_version'           => $bcfg['minor_version'],
                        'copyright'               => $bcfg['copyright'],
                        'about'                   => $bcfg['about'],
                        'hide_about'              => $bcfg['hide_about'],
                        'hide_legal'              => $bcfg['hide_legal'],
                        'hide_credits'            => $bcfg['hide_credits'],
                        'hide_trademarks'         => $bcfg['hide_trademarks'],
                        'hide_footer_left'        => $bcfg['hide_footer_left'],
                        'hide_core_verify_header' => $bcfg['hide_core_verify_header'],
                        'contact_support'         => $bcfg['contact_support'],
                        'contact_sales'           => $bcfg['contact_sales'],
                        'contact_web'             => $bcfg['contact_web'],
                        'sales_email'             => $bcfg['sales_email'],
                    );
                }
                break;
            default:
                $response = array('error' => _('Invalid command'));
                break;
        }
        break;
    default:
        $response = array('error' => _('Invalid request method'));
        break;
}

$response = json_encode($response);
echo $response;