<?php
header('Content-Type: application/json');

require_once(dirname(__FILE__) . '/../../includes/common.inc.php');
require_once(dirname(__FILE__) . '/../../includes/utils-users.inc.php');
require_once(dirname(__FILE__) . '/../../includes/utils.inc.php');

pre_init();
init_session(true);

grab_request_vars();
check_prereqs();
check_authentication(false, false, false, true);

// Read JSON input
$data = json_decode(file_get_contents("php://input"), true);

function getLanguage() {
    $user_id = $_SESSION["user_id"];
    $meta = get_user_meta($user_id, "language");
    return ['language' => $meta]; 
}

// Process the request based on the payload
$response = [];
if (isset($data['action'])) {
    switch ($data['action']) {
        case 'getLanguage':
            $response = getLanguage();
            break;
        default:
            $response['error'] = 'Invalid action';
    }
} else {
    $response = ['error' => 'No action specified'];
}

// Send response
echo json_encode($response);
?>
